Ameba::Rule::Style::LargeNumbers - ameba 1.7.0

# class Ameba::Rule::Style::LargeNumbers

- Ameba::Rule::Style::LargeNumbers
- Ameba::Rule::Base
- Reference
- Object

##
Overview

A rule that disallows usage of large numbers without underscore. These do not affect the value of the number, but can help read large numbers more easily.

For example, these are considered invalid:

    100000
    141592654
    5.123456

And has to be rewritten as the following:

    100_000
    141_592_654
    5.123_456

YAML configuration example:

    Style/LargeNumbers:
      Enabled: true
      IntMinDigits: 6 # i.e. integers higher than 99999

##
Included Modules

- Ameba::AST::Util
- YAML::Serializable

##
Defined in:

ameba/rule/style/large_numbers.cr

##
Constant Summary

MSG = `"Large numbers should be written with underscores: `%s`"`

##
Constructors

- .new(ctx : YAML::ParseContext, node : YAML::Nodes::Node)
- .new(config = nil)

  A rule that disallows usage of large numbers without underscore.

- .new(*, __context_for_yaml_serializable ctx : YAML::ParseContext, __node_for_yaml_serializable node : YAML::Nodes::Node)

##
Class Method Summary

- .deprecated?

  Returns `true` if this rule is deprecated, `false` otherwise.

- .deprecation_reason : String | Nil

  Returns the deprecation reason for this rule, if there is any.

- .documentation_url : String

  Returns the documentation URL for this rule.

- .parsed_doc : String | Nil

  Returns the documentation for this rule, if there is any.

- .to_json_schema(builder : JSON::Builder) : Nil

##
Instance Method Summary

- #description : String
- #description=(description : String)
- #enabled=(enabled : Bool)
- #enabled? : Bool
- #excluded : Set(String) | Nil
- #excluded=(excluded : Set(String) | Nil)
- #int_min_digits : Int32
- #int_min_digits=(int_min_digits : Int32)
- #severity : Ameba::Severity
- #severity=(severity : Ameba::Severity)
- #since_version : SemanticVersion | Nil
- #since_version=(since_version : String)
- #test(source)

### Instance methods inherited from module `Ameba::AST::Util`

abort?(node) abort?, control_exp_code(node : Crystal::ControlExpression, code_lines) control_exp_code, dynamic_literal?(node) : Bool dynamic_literal?, each_inline_directive(source, &block : Crystal::Token, String, Array(String) -> _) each_inline_directive, exit?(node) exit?, flow_command?(node, in_loop) flow_command?, flow_expression?(node, in_loop = false) flow_expression?, has_arguments?(node) : Bool has_arguments?, has_block?(node) : Bool has_block?, has_short_block?(node, code_lines) has_short_block?, heredoc?(node : Crystal::ASTNode, source : Source) heredoc?, literal?(node) : Bool literal?, loop?(node) loop?, name_end_location(node) name_end_location, name_location(node) name_location, name_location_or(token : Crystal::Token, name, *, adjust_location_column_number = nil)
name_location_or(node : Crystal::ASTNode, *, adjust_location_column_number = nil) name_location_or, name_size(node) name_size, node_source(node, code_lines) node_source, nodoc?(node) nodoc?, operator_method?(node) operator_method?, operator_method_name?(name : String) operator_method_name?, path_name(node : Crystal::Path, *, include_global = true) : String path_name, path_named?(node, *names : String) : Bool path_named?, raise?(node) raise?, setter_method?(node) setter_method?, setter_method_name?(name : String) setter_method_name?, short_block?(node, code_lines) short_block?, source_between(loc, end_loc, code_lines) : String | Nil source_between, static_literal?(node) : Bool static_literal?, suffix?(node) suffix?, takes_arguments?(node) : Bool takes_arguments?

### Instance methods inherited from class `Ameba::Rule::Base`

==(other : self) ==, catch(source : Source) catch, excluded?(source, root = Dir.current) excluded?, group group, hash(hasher) hash, name name, special? special?, test(source : Source, node : Crystal::ASTNode, *opts)
test(source : Source) test

### Class methods inherited from class `Ameba::Rule::Base`

default_severity : Ameba::Severity default_severity, group_name group_name, rule_name rule_name

### Macros inherited from class `Ameba::Rule::Base`

issue_for(*args, **kwargs, &block) issue_for

### Macros inherited from module `Ameba::Config::RuleConfig`

properties(&block) properties

##
Constructor Detail

def self.new(ctx : YAML::ParseContext, node : YAML::Nodes::Node) #
def self.new(config = nil) #

A rule that disallows usage of large numbers without underscore. These do not affect the value of the number, but can help read large numbers more easily.

For example, these are considered invalid:

    100000
    141592654
    5.123456

And has to be rewritten as the following:

    100_000
    141_592_654
    5.123_456

YAML configuration example:

    Style/LargeNumbers:
      Enabled: true
      IntMinDigits: 6 # i.e. integers higher than 99999

def self.new(*, __context_for_yaml_serializable ctx : YAML::ParseContext, __node_for_yaml_serializable node : YAML::Nodes::Node) #

##
Class Method Detail

def self.deprecated? #

Returns `true` if this rule is deprecated, `false` otherwise.

def self.deprecation_reason : String | Nil #

Returns the deprecation reason for this rule, if there is any.

def self.documentation_url : String #

Returns the documentation URL for this rule.

    Ameba::Rule::Lint::Syntax.documentation_url
    # => "https://crystal-ameba.org/api/master/Ameba/Rule/Lint/Syntax.html"

def self.parsed_doc : String | Nil #

Returns the documentation for this rule, if there is any.

    module Ameba
      # This is a test rule.
      # Does nothing.
      class Rule::MyRule < Rule::Base
        def test(source)
        end
      end
    end

    Ameba::Rule::MyRule.parsed_doc # => "This is a test rule.\nDoes nothing."

def self.to_json_schema(builder : JSON::Builder) : Nil #

##
Instance Method Detail

def description : String #
def description=(description : String) #
def enabled=(enabled : Bool) #
def enabled? : Bool #
def excluded : Set(String) | Nil #
def excluded=(excluded : Set(String) | Nil) #
def int_min_digits : Int32 #
def int_min_digits=(int_min_digits : Int32) #
def severity : Ameba::Severity #
def severity=(severity : Ameba::Severity) #
def since_version : SemanticVersion | Nil #
def since_version=(since_version : String) #
def test(source) #